#if !defined(luautilH)
#define luautilH

#if !defined(_MBCS)
#define _MBCS
#endif
#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"

#if defined __cplusplus
extern "C"{
#endif
/*<---------------------------------------------------------------------->*/
int luautil_init(void);
int luautil_args2str( lua_State *L, char *buf, int bufsize);
int luautil_print_lua_error(lua_State *L);
void luautil_arg_error_log( lua_State *L, const char *funcname);
int luautil_currentline(lua_State *L);
int luautil_currentsrc(lua_State *L, char const **src, int *curline);
lua_State *luautil_load_lua(const char *lua_file, const char *lua_path);
void luautil_free_lua(lua_State *L);
void luautil_fook_warning(lua_State *L);
void luautil_get_table_int(lua_State *L, int index, const char *key, int *value);
void luautil_get_table_string(lua_State *L, int index, const char *key, const char **value);
/*<---------------------------------------------------------------------->*/
#if defined __cplusplus
}
#endif
#endif
