#if !defined(charbmpH)
#define charbmpH

#include "SDL.h"

typedef struct TCHR_FONT_BMP CHR_FONT_BMP;

CHR_FONT_BMP* charbmp_alloc(void);
void charbmp_free(CHR_FONT_BMP*);
int charbmp_load(CHR_FONT_BMP *font_bmp, const char *file_code, const char *file_bmp, int chr_w, int chr_h, const char *font_name);
int charbmp_draw_char_rgba(CHR_FONT_BMP *font_bmp, SDL_Surface *dst, int x, int y, int code, Uint32 rgba);
int charbmp_draw_char(CHR_FONT_BMP *font_bmp, SDL_Surface *dst, int x, int y, int code);
int charbmp_draw_string_rgba(CHR_FONT_BMP *font_bmp, SDL_Surface *dst, int x, int y, const char *str, Uint32 rgba);
int charbmp_draw_string(CHR_FONT_BMP *font_bmp, SDL_Surface *dst, int x, int y, const char *str);
void charbmp_get_charsize(const CHR_FONT_BMP *font_bmp, int *w, int *h);

#endif
