//---------------------------------------------------------------------------
#ifndef drawcharH
#define drawcharH

extern "C"{
#include "charbmp.h"
}
//---------------------------------------------------------------------------
class TCharacterDrawerOnSDL
{
protected:
    CHR_FONT_BMP *m_font_bmp;   // e[uS
public:
    TCharacterDrawerOnSDL(void);
    virtual ~TCharacterDrawerOnSDL(void);
    int Initialize(SDL_PixelFormat *format, int fontsize, const char* fontname);
    int DrawString(SDL_Surface *surface, int x, int y, const char *str, Uint32 rgba=0xffffffff);
    int DrawStringWithNewLine(SDL_Surface *surface, int x, int y, const char *str, int ystep, Uint32 rgba=0xffffffff);
    int GetCharHeight() const;
    int GetStringWidth(const char* text) const;
};
//---------------------------------------------------------------------------
#endif
