#if !defined(gcnopenglimageliteH)
#define gcnopenglimageliteH

#if defined (_WIN32)
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#endif

#if defined (__amigaos4__)
#include <mgl/gl.h>
#elif defined (__APPLE__)
#include <OpenGL/gl.h>
#else
#include <GL/gl.h>
#endif

#include <string>

#include <guichan/color.hpp>
#include <guichan/platform.hpp>
#include <guichan/opengl/openglimage.hpp>

// gcn::OpenGLImage͗]ȏ̂Ōpė]ȏ폜Ă݂NXB
// \zAmPixels͏NULLƂȂɃeNX`B
class GCN_EXTENSION_DECLSPEC TGcnOpenGLImageLite : public gcn::OpenGLImage
{
public:
    TGcnOpenGLImageLite(const unsigned int* pixels, int width, int height, bool convertToDisplayFormat = true);
    //TGcnOpenGLImageLite(GLuint textureHandle, int width, int height, bool autoFree);
    virtual ~TGcnOpenGLImageLite();

    // Inherited from gcn::Image
    // gcn::OpenGLImage̎ꕔI[o[ChB

    //virtual void free();

    //virtual int getWidth() const;

    //virtual int getHeight() const;

    virtual gcn::Color getPixel(int x, int y);

    virtual void putPixel(int x, int y, const gcn::Color& color);

    virtual void convertToDisplayFormat();
};
#endif
