//---------------------------------------------------------------------------
#include "charaplace.h"
#include "ofini.h"
#include "gamemaster.h"
#include "gcnskinmanager.h"
//---------------------------------------------------------------------------
TCharaPlaceWindow::TCharaPlaceWindow() :
    m_Shown(false)
{
    setOpaque(false);
}
//---------------------------------------------------------------------------
void TCharaPlaceWindow::Show()
{
    if(!m_Shown){
        const TGcnSkinManager *skinmng = g_GameMaster.GetSkinManager();
        skinmng->ApplyWindowSkin(this);
        m_CharaListPane.setBackgroundColor(skinmng->GetSkin()->GetColorValue(TOpenFarenSkin::SKINCOLOR_DARKPANE));
        add(&m_CharaListPane);
        resizeToContent();
        m_Shown = true;
    }
    m_CharaListPane.SetSelected(0);
    setVisible(true);
}
//---------------------------------------------------------------------------
