//---------------------------------------------------------------------------
#include "imagepanelarge.h"
#include "logger.h"
//---------------------------------------------------------------------------
TGcnImagePaneLarge::TGcnImagePaneLarge()
{
}
//---------------------------------------------------------------------------
TGcnImagePaneLarge::~TGcnImagePaneLarge()
{
}
//---------------------------------------------------------------------------
void TGcnImagePaneLarge::draw(gcn::Graphics* g)
{
    int x = 0, y = 0;
    unsigned sz = m_ImageList.size();
    for(unsigned u=0; u<sz; ++u){
        gcn::Image *img = m_ImageList[u];
        g->drawImage(img, x, y);
        if((u % m_XCount) == m_XCount - 1){
            x = 0;
            y += img->getHeight();
        }
        else{
            x += img->getWidth();
        }
    }
}
//---------------------------------------------------------------------------
void TGcnImagePaneLarge::SetImage(const std::vector<gcn::Image*>& imglist, int xcount)
{
    unsigned sz = imglist.size();
    if(xcount > sz){
        OFWRNLOG("ȃp[^łB");
        return;
    }
    // ɕԉ摜͑SēcA̍v͑SẲтœƂB
    // ̉肪藧ĂȂPɕςȕ\܂͎sŖ\ƂB
    int w = 0;
    for(int i=0; i<xcount; ++i){
        w += imglist[i]->getWidth();
    }
    int h = 0;
    for(unsigned u=0; u<sz; ++u){
        if(!(u % xcount)){
            h += imglist[u]->getHeight();
        }
    }
    if(!w || !h){
        OFWRNLOG("摜Xg𖞂ĂȂ̂ō\zɎs܂B");
        return;
    }
    m_ImageList = imglist;
    m_XCount = xcount;
    setSize(w, h);
}
//---------------------------------------------------------------------------
