#include "mtrand.h"
#include <ctime>

boost::mt19937 mt_gen( static_cast<unsigned long>(std::time(0)) );
boost::uniform_smallint<> dst(0, MTRAND_MAX);
boost::variate_generator<boost::mt19937, boost::uniform_smallint<> > mtrand(mt_gen, dst);

// [0, n)͈̗̔͂B
int mtrand_n(int n)
{
    return mtrand() / (MTRAND_MAX / n + 1);
}
