#include "neighbor.h"
#include "logger.h"
#include "boostformat.h"
#include <algorithm>

// ǒn헪̃wNXƎĂ̂ŋǒn헪̃\[Xg񂷁BiYW̃wNXEɂ炷_ǒn헪Ƌtj
std::vector<point_t> TNeighbor::m_NeighborList[2];
std::vector<int> TNeighbor::m_NeighborIndex;
//const int TNeighbor::NextDX[2][6]={{0,1,1,1,0,-1},{-1,0,1,0,-1,-1}},
const int TNeighbor::NextDX[2][6]={{-1,0,1,0,-1,-1}, {0,1,1,1,0,-1}},
          TNeighbor::NextDY[6]={-1,-1,0,1,1,0};
//---------------------------------------------------------------------------
int TNeighbor::GenerateNeighborList(int mode,int index_from,int index_current,int center_x,int center_y)
{
    int i,x,y,odd;

    odd = (center_y >= 0 ? center_y : -center_y)%2;
    for(i=0;i<6;i++){
        //w肳ꂽW̎͂̍WɂāA
        x = center_x + NextDX[odd][i];
        y = center_y + NextDY[i];
        //܂XgɓĂȂWȂ烊XgɉB
        if(GetNeighborIndex(mode,x,y,index_from,index_current) == -1){
            if(index_current >= m_NeighborList[mode].size()){
                g_Logger.ErrorLog("ߖTWZoŃI[o[t[N܂B");
                return -1;
            }
            m_NeighborList[mode][index_current].x = x;
            m_NeighborList[mode][index_current].y = y;
            index_current++;
        }
    }
    return index_current;
}
//---------------------------------------------------------------------------
//index_from index_to-1 ͈̔͂Ŏw肳ꂽWXgTB
//߂l͌΂̃CfbNXAȂ-1
//mode ͍ŏ̒ŜxW̎1,̎0
int TNeighbor::GetNeighborIndex(int mode,int x,int y,int index_from,int index_to)
{
    for(int i=index_from;i<index_to;i++){
        if(x==m_NeighborList[mode][i].x && y==m_NeighborList[mode][i].y)
            return i;
    }
    return -1;
}
//---------------------------------------------------------------------------
void TNeighbor::GetRadius(int x, int y, int w, int h, int radius, std::vector<point_t>& v)
{
    v.reserve(GetNeighborNeedSize(radius));
    int to = m_NeighborIndex[radius + 1];
    const std::vector<point_t>& src = m_NeighborList[y%2];
    for(int i=0; i<to; ++i){
        int nx = x + src[i].x;
        int ny = y + src[i].y;
        if(nx >= 0 && nx < w && ny >= 0 && ny < h){
            v.push_back(point_t(nx, ny));
        }
    }
}
//---------------------------------------------------------------------------
void TNeighbor::Init()
{
    m_NeighborList[0].resize(GetNeighborNeedSize(NEIGHBOR_MAX));
    m_NeighborList[1].resize(GetNeighborNeedSize(NEIGHBOR_MAX));
    m_NeighborIndex.resize(NEIGHBOR_MAX + 2);

    int index_from,index_current;

    for(int mode=0;mode<2;mode++){
        m_NeighborList[mode][0].x = 0;
        m_NeighborList[mode][0].y = mode;
        m_NeighborIndex[0] = 0;
        m_NeighborIndex[1] = 1;
        index_from = 0;
        index_current = 1;
        for(int radius=1;radius<=NEIGHBOR_MAX;radius++){
            for(int i=m_NeighborIndex[radius-1];i<m_NeighborIndex[radius];i++){
                int new_index = GenerateNeighborList(mode, index_from, index_current, m_NeighborList[mode][i].x, m_NeighborList[mode][i].y);
                if(new_index == -1)
                    break;
                index_current = new_index;
            }
            //std::sort(&m_NeighborList[mode][m_NeighborIndex[radius]], &m_NeighborList[mode][index_current - 1] + 1, TPointLess()); // ϗvȂ
            m_NeighborIndex[radius+1] = index_current;
            index_from = m_NeighborIndex[radius-1];
        }
    }
    //SW͕̎֋X(0,1)̋ߖT̍W߁A
    //yW1ďCB
    for(int i=0;i<index_current;i++){
        m_NeighborList[1][i].y--;
    }
}
//---------------------------------------------------------------------------
