//---------------------------------------------------------------------------
#ifndef textpaneH
#define textpaneH

#include <string>
#include <guichan.hpp>
#include "gcnchar.h"
//---------------------------------------------------------------------------
class TGcnTextPane : public gcn::Widget
{
private:
    std::string m_text;
    int m_fontsize;
    int m_yspacing;
    TGcnCharDrawer *m_drawer;
    //gcn::Color m_bgcolor;
    //gcn::Color m_fgcolor;
public:
    TGcnTextPane();
    explicit TGcnTextPane(const std::string& s, int fontsize = 16);
    virtual ~TGcnTextPane();
    void SetText(const std::string& s);
    void SetFontSize(int fontsize);
    void SetYSpacing(int ysp) { m_yspacing = ysp; };
    void AdjustSize();
    virtual void draw(gcn::Graphics* g);
};
//---------------------------------------------------------------------------
#endif
