//---------------------------------------------------------------------------
#ifndef drawchar_win32H
#define drawchar_win32H

#include "SDL.h"

#include <windows.h>

//---------------------------------------------------------------------------
class TCharacterDrawerSDLWin32
{
private:
    SDL_Surface *m_SurfaceTemp;
    HDC m_hdc;
    HBITMAP m_hbmp;
    BYTE *m_pbits;
    HFONT m_hfont;
    int m_fontsize;
    int m_width;
    int m_height;
public:
    TCharacterDrawerSDLWin32(void);
    virtual ~TCharacterDrawerSDLWin32(void);
private:
    void DeleteMyObject(void);
public:
    void Initialize(SDL_PixelFormat *format, int planewidth, int planeheight);
    int DrawStringToSurface(SDL_Surface *surface, int x, int y, const char *str, const char *fontname, int fontsize, Uint32 rgba);
};
//---------------------------------------------------------------------------
#endif
