//---------------------------------------------------------------------------
#ifndef fpspaneH
#define fpspaneH

#include <boost/circular_buffer.hpp>
#include <guichan.hpp>
#include <SDL.h>
//---------------------------------------------------------------------------
class TGcnFPSPane : public gcn::Widget
{
private:
    boost::circular_buffer<Uint32> m_Buf;
    Uint32 m_LastTick;
    Uint32 m_LastFPS;
public:
    TGcnFPSPane(int maxfps);
    virtual ~TGcnFPSPane();
    virtual void draw(gcn::Graphics* g);
    virtual void logic();
    void SetTick(Uint32 tick);
};
//---------------------------------------------------------------------------
#endif
