//---------------------------------------------------------------------------

#include <vcl.h>
#include <io.h>
#pragma hdrstop
#include <shlobj.h>
#include <boost/scoped_ptr.hpp>

#include "FarencnvForm.h"
#include "cnv.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
int __stdcall BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam,  LPARAM lpData)
{
	if (uMsg == BFFM_INITIALIZED) {
		SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);
	}
	return 0;
}
//---------------------------------------------------------------------------
bool ExecuteFolderDialog(HWND hWnd, TCHAR* szStartPath, TCHAR* szDisplayName)
{
	BROWSEINFO bInfo;
	LPITEMIDLIST pIDList;

	// BROWSEINFO\̂ɒlݒ
	ZeroMemory(&bInfo, sizeof bInfo);
	bInfo.hwndOwner             = hWnd;          					// _CAO̐eEChẼnh
	bInfo.pidlRoot              = NULL;                             // [gtH_ITEMIDLIST̃|C^ (NULL̏ꍇfXNgbvtH_g܂j
	bInfo.pszDisplayName        = szDisplayName;                    // IꂽtH_󂯎obt@̃|C^
	bInfo.lpszTitle             = _T("tH_̑I");             // c[r[̏㕔ɕ\镶
	bInfo.ulFlags               = BIF_RETURNONLYFSDIRS;             // \tH_̎ނtO
	bInfo.lpfn                  = BrowseCallbackProc;               // BrowseCallbackProc֐̃|C^
	bInfo.lParam                = (LPARAM)szStartPath;              // R[obN֐ɓnl

	// tH_I_CAO\
	pIDList = ::SHBrowseForFolder(&bInfo);
	if(pIDList == NULL){

		// ߂lNULL̏ꍇAtH_IꂸɃ_CAOꂽƂӖ܂B
		return false;
	}else{

		// ItemIDListpXɕϊ܂
		if(!::SHGetPathFromIDList(pIDList, szDisplayName)){
			// G[
			return false;
		}
		// szDisplayNameɑIꂽtH_̃pXĂ܂


		// ŌpIDList̃|CgĂ郁J܂
		::CoTaskMemFree( pIDList );
		return true;
	}
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	if(!_access("openfaren.exe", 0)){
		Edit_src->Text = "C:\\Program Files\\AtAt\\Faren\\Default";
		char curdir[MAX_PATH];
		GetCurrentDirectory(sizeof curdir, curdir);
		AnsiString dstdir;
		dstdir.sprintf("%s\\Scenario", curdir);
		Edit_dst->Text = dstdir;
		if(_access(dstdir.c_str(), 0)){
			CreateDirectory(dstdir.c_str(), NULL);
		}
        // ꊇϊXg̏ꏊ
		dstdir.sprintf("%s\\cnv.txt", curdir);
		Edit_txt->Text = dstdir;
        // Ro[g\[X̏ꏊ
        m_CnvSrcPath = "cnvsrc";
	}
    else{
        // Jł͌ŒB
        m_CnvSrcPath = "D:\\My Documents\\bcbuser\\farencnv\\cnvsrc";
    }
    UpdateControlEnabled();
	//Edit_src->Text = "D:\\temp\\RoR";
	//Edit_src->Text = "D:\\temp\\I]e嗤";
	//Edit_src->Text = "D:\\temp\\VeXgpViI";
	//Edit_src->Text = "D:\\temp\\mc";
	//Edit_src->Text = "D:\\temp\\퍑̓";
	//Edit_src->Text = "D:\\temp\\geBA";
	//Edit_src->Text = "D:\\temp\\reafan";
	//Edit_src->Text = "D:\\temp\\erictis";
	//Edit_src->Text = "D:\\temp\\farentk109";
	//Edit_src->Text = "D:\\temp\\Geoground";
	//Edit_src->Text = "D:\\temp\\AfterM_2";
	//Edit_src->Text = "D:\\temp\\G[gD[K";
	//Edit_src->Text = "D:\\temp\\̑嗤";
	//Edit_src->Text = "D:\\temp\\hikakage";
	//Edit_src->Text = "D:\\temp\\푈̕";
	//Edit_src->Text = "D:\\temp\\rpƋ]";
    //Edit_src->Text = "D:\\temp\\CYIubh";
	//Edit_src->Text = "D:\\temp\\߂";
	//Edit_src->Text = "D:\\temp\\t@";
	//Edit_src->Text = "D:\\temp\\times";
    //Edit_src->Text = "D:\\temp\\FTE0300";
    //Edit_src->Text = "D:\\temp\\boardonkights";
    //Edit_src->Text = "D:\\temp\\FarenAfter70";
    //Edit_src->Text = "D:\\temp\\mean";
}
//---------------------------------------------------------------------------
__fastcall TForm1::SetProgressBar(int pos)
{
	ProgressBar_cnv->Position = pos;
	Application->ProcessMessages();
	return 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_srcClick(TObject *Sender)
{
	TCHAR *inipath;
	TCHAR dirpath[MAX_PATH];
	if(Sender == Button_src){
		inipath = Edit_src->Text.c_str();
	}else{
		inipath = Edit_dst->Text.c_str();
	}
	if(ExecuteFolderDialog(Handle, inipath, dirpath)){
		if(Sender == Button_src){
			Edit_src->Text = dirpath;
		}else{
			Edit_dst->Text = dirpath;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_cnvClick(TObject *Sender)
{
	Button_cnv->Enabled = false;
    if(RadioButton_Single->Checked){
        // ʕϊ
        boost::scoped_ptr<TFarenCnv> cnv(new TFarenCnv);
        cnv->SetCnvSrcPath(m_CnvSrcPath.c_str());
        if(cnv->ConvertFarenScenario(Edit_src->Text.c_str(), Edit_dst->Text.c_str(), CheckBox_ConvertScript->Checked, CheckBox_NoDefault->Checked)){
	    	ShowMessage("ϊɐ܂B");
    	}
        else{
	    	ShowMessage("ϊɎs܂B");
        }
    }
    else{
        // ꊇϊ
        FILE *fp = fopen(Edit_txt->Text.c_str(), "r");
        if(fp == NULL){
            AnsiString str;
            str.sprintf("%s J܂łB", Edit_txt->Text.c_str());
	    	ShowMessage(str);
            return;
        }
        FILE *fp_log = fopen("log.txt", "w");
        if(fp_log == NULL){
            fclose(fp);
	    	ShowMessage("Ot@C쐬ł܂łB");
            return;
        }
        char buf[1024];
        while(fgets(buf, sizeof buf, fp) != NULL){
            if(buf[0] == '\0' || buf[0] == '\n' || buf[0] == '#'){
                continue;
            }
            char *p = strchr(buf, '\n');
            if(p != NULL){
                *p = '\0';
            }
            boost::scoped_ptr<TFarenCnv> cnv(new TFarenCnv);
            cnv->SetCnvSrcPath(m_CnvSrcPath.c_str());
            AnsiString scename = ExtractFileName(buf);
            AnsiString logfile;
            logfile.sprintf("%s\\%s.txt", Edit_dst->Text.c_str(), scename.c_str());
            cnv->SetLogFileName(logfile.c_str());
            if(cnv->ConvertFarenScenario(buf, Edit_dst->Text.c_str(), CheckBox_ConvertScript->Checked, CheckBox_NoDefault->Checked)){
                fprintf(fp_log, " %s\n", buf);
            }
            else{
                fprintf(fp_log, "~s %s\n", buf);
            }
        }
        fclose(fp);
        fclose(fp_log);
      	ShowMessage("ϊI܂Bۂlog.txtɏo͂܂B");
    }
	SetProgressBar(0);
	Button_cnv->Enabled = true;
	if(CheckBox_ExitOnEnd->Checked){
    	Close();
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_txtClick(TObject *Sender)
{
	TCHAR *inipath;
	TCHAR dirpath[MAX_PATH];
    OpenTextFileDialog_txt->InitialDir = ExtractFileDir(Edit_txt->Text);
    if(OpenTextFileDialog_txt->Execute()){
        Edit_txt->Text = OpenTextFileDialog_txt->FileName;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button_txteditClick(TObject *Sender)
{
    ShellExecute(Handle, "edit", Edit_txt->Text.c_str(), NULL, NULL, SW_SHOW);
}
//---------------------------------------------------------------------------
__fastcall TForm1::UpdateControlEnabled()
{
    bool single = RadioButton_Single->Checked;
    Edit_src->Enabled = single;
    Button_src->Enabled = single;
    Edit_txt->Enabled = !single;
    Button_txt->Enabled = !single;
    Button_txtedit->Enabled = !single;
	return 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioButtonClick(TObject *Sender)
{
    UpdateControlEnabled();
}
//---------------------------------------------------------------------------

