#include "farentxt.h"
#include <stdio.h>
#include <string.h>

//---------------------------------------------------------------------------
bool TFarenTxt::LoadFromFile(const char *filename)
{
    m_TxtList.clear();
    m_CategoryIndex.clear();

    FILE *fp = fopen(filename, "r");
    if(fp == NULL){
        return false;
    }

    char buf[1024];
    std::string lastcat;

    // [xxx]̓JeSƂB
    lastcat = "";
    m_CategoryIndex[lastcat] = 0;
    m_CategorySize[lastcat] = 0;

    while(fgets(buf, sizeof buf, fp) != NULL){
        char *p = strchr(buf, '\n');
        if(p == buf){
            // s͖
            continue;
        }
        if(p != NULL){
            *p = '\0';
        }
        bool iscat = false;
        int i;
        if(buf[0] == '['){
            i = strlen(buf);
            iscat = (buf[i - 1] == ']');
        }
        if(iscat){
            buf[i - 1] = '\0';
            lastcat = &buf[1];
            m_CategoryIndex[lastcat] = m_TxtList.size();
        }
        else{
            m_TxtList.push_back(buf);
            m_CategorySize[lastcat]++;  // ̂Ō
        }
    }
	fclose(fp);

    return true;
}
//---------------------------------------------------------------------------
bool TFarenTxt::GetCategory(const char *catname, int *index, int *count)
{
    std::map<std::string, int>::const_iterator itr = m_CategoryIndex.find(catname);
    if(itr != m_CategoryIndex.end())
    {
        *index = itr->second;
        *count = m_CategorySize[catname];   // 2񌟍̂Ō
        return true;
    }
    return false;
}
//---------------------------------------------------------------------------
const std::string& TFarenTxt::GetString(int index) const
{
    return m_TxtList[index];
}
//---------------------------------------------------------------------------
void TFarenTxt::GetString(int index, std::string& str) const
{
    str = m_TxtList[index];
}
//---------------------------------------------------------------------------
int GetIntValuesSpace(const char *str, int *values, int valuemax)
{
    const char *p = str;
    int i;
    for(i=0; i<valuemax; i++){
        if(i){
            p = strchr(p, ' ');
            if(p == NULL){
                return i;
            }
            p++;
        }
        if(sscanf(p, "%d", &values[i]) != 1){
            return i;
        }
    }
    return i;
}
