//---------------------------------------------------------------------------
#ifndef formulaH
#define formulaH

#include "ofdata.h"
#include "ofgame.h"
//---------------------------------------------------------------------------
void GetEffectPower(const TCharacterInstance& atkchara, const TCharacterInstance& defchara, const TSpecial& spe, int *atk, int *def, int *hit, int *avoid);
int FormulaFTAttack(const TBattleMap& btmap, const TCharacterInstance& atkchara, const TCharacterInstance& defchara, const TSpecial& spe, int power, bool isCure);
int FormulaFTSpecial(const TBattleMap& btmap, const TCharacterInstance& atkchara, const TCharacterInstance& defchara, const TSpecial& spe, int power, bool isCure);
int FormulaFTMagic(const TBattleMap& btmap, const TCharacterInstance& atkchara, const TCharacterInstance& defchara, const TSpecial& spe, int power, bool isCure);
int FormulaFTAttackHit(const TBattleMap& btmap, const TCharacterInstance& atkchara, const TCharacterInstance& defchara, const TSpecial& spe, int power, bool isCure);
int FormulaFTMagicHit(const TBattleMap& btmap, const TCharacterInstance& atkchara, const TCharacterInstance& defchara, const TSpecial& spe, int power, bool isCure);

int EvalExperience(const TCharacterInstance& c, bool actioned, std::vector<const TCharacterInstance*> killlist);
bool HasAttack(const TBattleCharacter& charadata);
void AddSystemEffect(TCharacterInstance& c, TSystemEffect addeffect);
void RemoveSystemEffect(TCharacterInstance& c, TSystemEffect addeffect);
bool HasSystemEffect(const TCharacterInstance& c, TSystemEffect addeffect);
bool CanAction(const TCharacterInstance& c);
//---------------------------------------------------------------------------
#endif
