//---------------------------------------------------------------------------
#ifndef hintpaneH
#define hintpaneH

#include <guichan.hpp>
#include <string>

class TGcnCharDrawer;
//---------------------------------------------------------------------------
class TGcnHintPane : public gcn::Widget
{
public:
    TGcnHintPane();
    virtual ~TGcnHintPane();
    virtual void draw(gcn::Graphics* g);
    virtual void logic();
    void SetCaption(const std::string& caption);
    void GoShown();
    void GoHidden();
private:
    static const int PADDING = 4;
    static const int LINEPADDING = 2;

    TGcnCharDrawer *m_Drawer;
    std::string m_Caption;
    int m_Alpha;
    int m_ShowStep;

    void GetNeedSize(const std::string& caption, int& w, int& h) const;
};
//---------------------------------------------------------------------------
#endif
