//---------------------------------------------------------------------------
#include "imagepane.h"
//---------------------------------------------------------------------------
TGcnImagePane::TGcnImagePane()
    : m_image(NULL)
{
}
//---------------------------------------------------------------------------
TGcnImagePane::TGcnImagePane(gcn::Image* img)
    : m_image(img)
{
    if(m_image != NULL){
        setSize(img->getWidth(), img->getHeight());
    }
}
//---------------------------------------------------------------------------
TGcnImagePane::~TGcnImagePane()
{
}
//---------------------------------------------------------------------------
void TGcnImagePane::SetImage(gcn::Image* img)
{
    m_image = img;
    if(m_image != NULL){
        setSize(img->getWidth(), img->getHeight());
    }
}
//---------------------------------------------------------------------------
void TGcnImagePane::draw(gcn::Graphics* g)
{
    if(m_image != NULL){
        g->drawImage(m_image, 0, 0);
    }
}
