#ifndef neighborH
#define neighborH

#include "oftypes.h"

//---------------------------------------------------------------------------
class TNeighbor
{
private:
    static std::vector<point_t> m_NeighborList[2];
    static std::vector<int> m_NeighborIndex;

    static int GenerateNeighborList(int mode,int index_from,int index_current,int center_x,int center_y);
    static int GetNeighborIndex(int mode,int x,int y,int index_from,int index_to);
    // NߖT\̂ɕKvȗvfB\sum^n_{k=1}(6k) = 3n^2 + 3n B+1 ͒SW̕B
    // N=32̎A3169ɂȂB
    static int GetNeighborNeedSize(int n) { return 3*(n*n + n) + 1; }
public:
    static void Init();
    // ȉ̊֐̓CC҂B
    static int GetNeighborIndex(int n) { return m_NeighborIndex[n]; }
    static point_t GetNeighbor(int mode, int index) { return m_NeighborList[mode][index]; }
    static void GetRadius(int x, int y, int w, int h, int radius, std::vector<point_t>& v);

    static const int NextDX[2][6];
    static const int NextDY[6];
    static const int NEIGHBOR_MAX = 32;
};
//---------------------------------------------------------------------------

#endif
