//---------------------------------------------------------------------------
#ifndef ofxmlH
#define ofxmlH

#include <string>
#include <tinyxml.h>

enum TEncoding
{
    ENCODING_SJIS,
    ENCODING_EUCJP,
    ENCODING_UTF8
};
//---------------------------------------------------------------------------
std::string GetElementText(const TiXmlElement& e);
std::string GetElementTextEncoding(const TiXmlElement& e, TEncoding enc = ENCODING_SJIS);
int GetElementInt(const TiXmlElement& e);
std::string GetElementAttribute(const TiXmlElement& e, const std::string& attrname);
bool FindIntAttribute(const TiXmlElement *e_src, const std::string& ename, const std::string& attrname, int *dst, const std::string& errlog);
void InsertTextChild(TiXmlElement& e, const char* str);
void SetTextAttribute(TiXmlElement& e, const char* name, const char* str);
//---------------------------------------------------------------------------
#endif
