//---------------------------------------------------------------------------
#include <algorithm>
#include "widgetset.h"
#include "boostformat.h"
#include "logger.h"
//---------------------------------------------------------------------------
TGcnWidgetSet::TGcnWidgetSet()
{
}
//---------------------------------------------------------------------------
TGcnWidgetSet::~TGcnWidgetSet()
{
    RemoveAll();
}
//---------------------------------------------------------------------------
void TGcnWidgetSet::Add(boost::shared_ptr<gcn::Widget> pw)
{
    m_WidgetList.push_back(pw);
}
//---------------------------------------------------------------------------
void TGcnWidgetSet::Remove(gcn::Widget* w)
{
    for(TGcnWidgetList::iterator itr = m_WidgetList.begin(); itr != m_WidgetList.end(); ++itr){
        if(itr->get() == w){
            m_WidgetList.erase(itr);
            return;
        }
    }
}
//---------------------------------------------------------------------------
void TGcnWidgetSet::RemoveAll()
{
    /*for(TGcnWidgetList::iterator itr = m_WidgetList.begin(); itr != m_WidgetList.end(); ++itr){
        itr->reset();
    }*/
    m_WidgetList.clear();
}
//---------------------------------------------------------------------------
