//---------------------------------------------------------------------------
#ifndef widgetsetH
#define widgetsetH

#include <list>
#include <boost/shared_ptr.hpp>
#include <guichan.hpp>

//---------------------------------------------------------------------------
class TGcnWidgetSet
{
public:
    TGcnWidgetSet();
    virtual ~TGcnWidgetSet();
    void Add(boost::shared_ptr<gcn::Widget> w);
    void Remove(gcn::Widget* w);
private:
    typedef std::list<boost::shared_ptr<gcn::Widget> > TGcnWidgetList;
    TGcnWidgetList m_WidgetList;

    void RemoveAll();
};
//---------------------------------------------------------------------------
#endif
